'
'  Init5.vbs
'
'  Initialize/upgrade Lotus Notes R5/Win32 workplace for UCVT user.
'
'  Uses UCVT-firmware scheme for placement personal data files
'  on the local and network drives.
'
'  Written by Evseev at Oct,Nov 2001, Feb 2002.
'  Educational Centre of Computer Science (UCVT), SPb, Russia~
'
'  Distribution site: http://www.evseev.ucvt.ru/e.nsf/AllDocs/init5/
'
'  Dev.note: by default, all functions return boolean
'            except specially notified cases.
'

option explicit

'----------------------------------------------------------------------
'  Variables and default values (may be adopted to other values)
'

const nbDominoServer = "NotesSrv"
const   nbFileServer = "NotesSrv"
const nbScriptServer = "NotesSrv"

const        BinPath = "d:\notes"
const       DataPath = "d:\notes\data"

const      UserDrive = "N:"

dim NetworkPath, ScriptPath, DistribPath

NetworkPath = "\\" &   nbFileServer & "\DomUsers"
 ScriptPath = "\\" & nbScriptServer & "\Scripts"
DistribPath = "\\" &   nbFileServer & "\RusNotes"

const LanPortName = "TCPIP"

const InstallNetwork       = 1   ' all user files on then network drive
const InstallLocal         = 2   ' all user files files on the local drive
const InstallSharedLocal   = 3   ' USER.ID on the network drive; NOTES.INI and shortcut on the local drive; personal databases and desktop are common for all users
const InstallSharedLocalID = 4   ' USER.ID, NOTES.INI and shortcut in the personal folder on the local drive; personal databases and desktop are common for all users
const InstallProgramOnly   = 5
dim InstallMode
InstallMode = InstallNetwork


dim UserLogin, UserName, LocalUserDir, NetworkUserDir, DirName
dim DominoServer, DominoServerIPAddr
dim AddDesktopShortcut, SetupLogFilename, ShowEndMsg
AddDesktopShortcut = false
ShowEndMsg = true


dim session, workspace     ' NotesSession, NotesUIWorkspace


'----------------------------------------------------------------------
'  Declare and init global-wide constants
'
const Slash           = "\"

' FileSystem.OpenTextFile
const ForReading      = 1
const ForWriting      = 2
const ForAppending    = 8

' File.Attributes
const faReadOnly      = 1  ' 2: hidden, 4: system, 16: dir, 32: archive

'onst vbBinaryCompare = 0
'onst vbTextCompare   = 1

' FileSystem.GetDrive.DriveType
const NetworkDrive    = 3  ' 0: unknown, 1: removable, 2: fixed, 4: CD, 5: RAM

' RunCommand
const RunWait         = true
const RunDontWait     = false

' RunCommand
const WindowMaximize  = 3
const WindowActivate  = 8
const WindowMinimizeDontGrabFocus = 7

' shell.Popup
const PopupTimeout   = -1


dim FileSystem, Network, Shell, Registry, Environment, TempDir

set  FileSystem = CreateObject("Scripting.FileSystemObject")
set     Network = WScript.CreateObject("WScript.Network")
set       Shell = WScript.CreateObject("WScript.Shell")
set    Registry = Shell
set Environment = shell.Environment

'----------------------------------------------------------------------

function InitTempDir

    InitTempDir = false
    TempDir = Environment("TEMP")
    if TempDir = "" then
        TempDir = "C:\Windows\Temp"
        if not fileSystem.FolderExists(TempDir) then
            TempDir = "C:\TEMP"
            if not fileSystem.FolderExists(TempDir) then
                if fileSystem.CreateFolder(TempDir) is nothing then exit function
            end if
        end if
    end if

    InitTempDir = true

    SetupLogFilename = TempDir & "\setup_r5.log"

end function  'InitTempDir


'----------------------------------------------------------------------
'  DebugMsg
'
dim DebugFile, FileDebugLevel, MsgboxDebugLevel

   set DebugFile = nothing
  FileDebugLevel = 100
MsgboxDebugLevel = 0

'DebugMsg:msgLevel
const FatalLevel        = -1
const ErrorLevel        =  0
const WarningLevel      =  1
const NotificationLevel =  2
const InformationLevel  =  3


private sub DebugMsg(msgLevel, msgWhere, msgText)
    if msgLevel <= fileDebugLevel then
        if debugFile is nothing then
            dim fn
            fn = TempDir & "\init5.log"
            if fileSystem.FileExists(fn) then
                set debugFile = fileSystem.OpenTextFile(fn, ForAppending, False)
            else
                set debugFile = fileSystem.OpenTextFile(fn, ForWriting, True)
            end if
            debugFile.WriteLine
            debugFile.WriteLine string(64, "=")
        end if
        debugFile.WriteLine Now & "  " & msgWhere & " [" & msgLevel & "]: " & msgText
    end if
    if msgLevel <= msgboxDebugLevel then
        MsgBox msgText, vbOkOnly, msgWhere & " - init5.vbs"
    end if
end sub

private sub errorMsg(msgWhere, msgText)
    debugMsg ErrorLevel, "ERROR " & msgWhere, msgText
end sub

private sub warningMsg(msgWhere, msgText)
    debugMsg WarningLevel, "Warning " & msgWhere, msgText
end sub

private sub infoMsg(msgWhere, msgText)
    debugMsg InformationLevel, "Information " & msgWhere, msgText
end sub

private function sleepMsg(nseconds, title, msg, flags)
    sleepMsg = shell.popup(msg, nseconds, title, flags)
end function

private function AskBox(msg, opts, title)
    dim result
    result = MsgBox(msg, opts, title)
    debugMsg 80, title, msg & " ..result = " & result
    Askbox = result
end function


'----------------------------------------------------------------------
'
private function Capitalize(str)  '...return String
   Capitalize = ucase(left(str,1)) & lcase(right(str,len(str)-1))
end function


'----------------------------------------------------------------------

private function safeRegistryRead(keyName, keyExist)
    keyExist = false
    safeRegistryRead = ""

    dim s
    on error resume next
    err.clear
    s = registry.RegRead(keyName)
    if err.number = 0 then
        keyExist = true
        safeRegistryRead = s
    end if
    err.clear

    debugMsg 98, "SafeRegistryRead", "Key " & keyName & ": " & keyExist
end function


private function IsNotesRegistryInstalled
    dim ok
    call safeRegistryRead("HKLM\Software\Lotus\Notes\5.0\", ok)
    if ok then call safeRegistryRead("HKLM\Software\Lotus\Notes\Path", ok)
    IsNotesRegistryInstalled = ok
    debugMsg 60, "IsNotesRegistryInstalled", ok
end function


private function IsNotesProgramInstalled
    IsNotesProgramInstalled = false
    if fileSystem.FileExists(BinPath & Slash & "notes.exe") then
        IsNotesProgramInstalled = true
        debugMsg 60, "IsNotesProgramInstalled", "True"
    else
        debugMsg 60, "IsNotesProgramInstalled", "False"
    end if
end function
    

private function IsNotesDataInstalled
    IsNotesDataInstalled = false
    if fileSystem.FolderExists(DataPath & Slash) then
        IsNotesDataInstalled = true
        debugMsg 60, "IsNotesDataInstalled", "True"
    else
        debugMsg 60, "IsNotesDataInstalled", "False"
    end if
end function

'----------------------------------------------------------------------

private function StartNotesInstaller
    StartNotesInstaller = false
    if fileSystem.FileExists(SetupLogFilename) then
        debugMsg 80, "StartLotusNotes", "Remove existing """ & SetupLogFilename & """"
        call fileSystem.DeleteFile(SetupLogFilename, true)
    end if
    dim s, i
    s = DistribPath & "\setup.exe" & _
      " /s /f1""" & ScriptPath & "\setup.iss"" /f2""" & SetupLogFilename & """"
    debugMsg 40, "StartNotesInstaller", s
    i = shell.Run(s, WindowMinimizeDontGrabFocus, RunWait)
    debugMsg 40, "StartNotesInstaller", "Result = " & i
    if i = 0 then StartNotesInstaller = true
end function


private function WaitFinishNotesInstaller
    WaitFinishNotesInstaller = false
    const name = "ResultCode="
    dim i, f, s, sectionOk, fileOkFirst, sectionOkFirst
    fileOkFirst = false
    sectionOkFirst = false
    do
        if fileSystem.FileExists(SetupLogFilename) then
            if not fileOkFirst then
                fileOkFirst = true
                debugMsg 40, "WaitFinishNotesInstaller", "Found " & SetupLogFilename
            end if
            sectionOk = false
            set f = fileSystem.OpenTextFile(SetupLogFilename, ForReading)
            do while not f.AtEndOfStream
                s = f.ReadLine
                if sectionOk then
                    if left(s, len(name)) = name then
                        if right(s, len(s) - len(name)) = "0" then
                            WaitFinishNotesInstaller = true
                            infoMsg "WaitFinishNotesInstaller", "Installer finished ok"
                        else
                            errorMsg "WaitFinishNotesInstaller", "Installer failed"
                        end if
                        exit function
                    end if
                elseIf s = "[ResponseResult]" then
                    sectionOk = true
                    if not sectionOkFirst then
                        sectionOkFirst = true
                        debugMsg 40, "WaitFinishNotesInstaller", "Found [ResponseResult] section"
                    end if
                end if
            loop
        end if
        i = sleepMsg(10, "init5.vbs", "Waithing until Notes installation finished", _
            vbOkCancel + vbInformation)
        if (i <> vbOk) and (i <> PopupTimeout) then
            infoMsg "WaitFinishNotesInstaller", "Canceled by user!"
            exit function
        end if
    loop
    errorMsg "WaitFinishNotesInstaller", "Installer finished???"
end function


private function ValidateNotes
    ValidateNotes = false

    dim regOk, regOk2, programOk, dataOk, mustBeInstalled, s
    s = ""
    mustBeInstalled = false
        regOk = IsNotesRegistryInstalled
    programOk = IsNotesProgramInstalled
   ''' dataOk = IsNotesDataInstalled

    if (not regOk) and (not programOk) then
        mustBeInstalled = true
    elseIf regOk and programOk then
        debugMsg 20, "ValidateNotes", "Lotus Notes is already installed"
        ValidateNotes = true
    elseIf regOk and (not programOk) then
        s = "Registry present, regpath = """ & _
            safeRegistryRead("HKLM\Software\Lotus\Notes\Path", regOk2) & """, " _
            & "but program folder """ & BinPath & """ not found."
    elseIf (not regOk) and programOk then
        s = "Program folder present, but registry entry not found."
    end if

    if s <> "" then
        if AskBox(s & " Install over?", vbYesNo + vbQuestion, "ValidateNotes") = vbYes then
            mustBeInstalled = true
        else
            infoMsg "ValidateNotes", "Program installation canceled by user."
        end if
    end if

    if mustBeInstalled then
        debugMsg 20, "ValidateNotes", "Lotus Notes will be installed now"
        if StartNotesInstaller then _
          if WaitFinishNotesInstaller then _
            ValidateNotes = true
    end if

    dim inifile
    inifile = BinPath & Slash & "notes.ini"
    if fileSystem.FileExists(inifile) then _
      call fileSystem.MoveFile(inifile, inifile & "_")

end function


'----------------------------------------------------------------------
'  ValidateFolder

private function ParentFolderName(folderName)  'return string
    dim i
    i = InStrRev(folderName, Slash, -1)
    if i > 0 then
        ParentFolderName = left(folderName, i - 1)
    else
        'fixme todo ??? !!! ?!?
    end if
end function

private function ValidateFolder(folderName, createNesting)
    ValidateFolder = false
    debugMsg 40, "ValidateFolder", "folder = """ & folderName & """, " & createNesting
    dim parentName, ok
    if fileSystem.FolderExists(folderName) then
        debugMsg 60, "ValidateFolder", "Folder already exists"
        ValidateFolder = true
        exit function
    end if
    parentName = ParentFolderName(folderName)
    if not fileSystem.folderExists(parentName) then
        if createNesting then
            ok = ValidateFolder(parentName, createNesting)
        else
            ok = false 
        end if
        if not ok then
            errorMsg "ValidateFolder", "Cannot create """ & folderName _
                & """ because """ & parentName & """ not exist"
            exit function
        end if
    end if
    debugMsg 80, "ValidateFolder", "Create """ & folderName & """ now..."
    fileSystem.CreateFolder(folderName)
    ValidateFolder = true
end function


'----------------------------------------------------------------------
'  IsNetworkDrivePersistent
'
private function IsNetworkDrivePersistent(DriveLetter)
    debugMsg 40, "IsNetworkDrivePersistent", "Drive = " & DriveLetter
    dim s, ok
    IsNetworkDrivePersistent = false
    s = safeRegistryRead("HKCU\Network\Persistent\" & Left(DriveLetter, 1) & "\RemotePath", ok)
    if s <> "" then IsNetworkDrivePersistent = true
    debugMsg 20, "IsNetworkDrivePersistent", "Result = " & ok & ", " & s
end function

'----------------------------------------------------------------------

private function CheckDirFile(Hint, TopPath, DirName, FileName)
    dim fullpath, ok, f
    ok = false
    fullpath = TopPath & Slash
    if  DirName <> "" then fullpath = fullpath & DirName
    if FileName <> "" then
        fullpath = fullpath & Slash & FileName
        ok = FileSystem.FileExists(fullpath)
        'fixme: check file is accessible for writing??? 
    else
        ok = FileSystem.FolderExists(fullpath)
    end if
    debugMsg 40, "CheckDirFile", Hint & " """ & fullpath & """: " & ok
    CheckDirFile = ok
end function

'----------------------------------------------------------------------
'  MapNetworkDrive
'
private function MapNetworkDrive(NetworkPath, DriveLetter, DirToCheck, FileToCheck)

    MapNetworkDrive = False
    debugMsg 40, "MapNetworkDrive(1)", _
      NetworkPath & ", " & DriveLetter & ", " & DirToCheck & ", " & FileToCheck
    '
    '  If network resource is already assigned to drive letter
    '  and required file is presented is user's directory => All OK
    '
    if CheckDirFile("Drive already created?", DriveLetter, DirToCheck, FileToCheck) then
        MapNetworkDrive = True
        exit function
    end if
    '
    '  If network resource not found
    '  or doesn't contain user's directory => This Bad
    '
    if not CheckDirFile("Network share exists?", NetworkPath, DirToCheck, FileToCheck) then
        errorMsg "Map network drive", "Cannot find remote share " _
            & NetworkPath & " that contains " & DirToCheck _
            & " directory with " & FileToCheck & " file."
        exit function
    end if
    '
    '  Now: assign network resource to drive letter
    '
    '  If drive letter is already assigned by something, unassign it first
    '
    if FileSystem.DriveExists(DriveLetter) then
        debugMsg 40, "MapNetworkDrive(6)", "Unassign " & DriveLetter
        dim DriveInfo
        set DriveInfo = fileSystem.GetDrive(DriveLetter)
        if DriveInfo.DriveType = NetworkDrive then _
          Network.RemoveNetworkDrive DriveLetter, True, True  '..force, update
        if FileSystem.DriveExists(DriveLetter) then
            errorMsg "Map network drive", "Cannot unassign drive " _
                & DriveLetter & " that is already mapped to something another."
            exit function
        end if
    end if
   
    debugMsg 80, "MapNetworkDrive(8)", "Try to map " & NetworkPath & " to " & DriveLetter
    Network.MapNetworkDrive DriveLetter, NetworkPath, _
        not IsNetworkDrivePersistent(DriveLetter)  '..updateProfile?
    '
    '  If assignment is successful => All OK
    '
    if CheckDirFile("Creation successful?", DriveLetter, DirToCheck, FileToCheck) then
        debugMsg 40, "MapNetworkDrive(9)", "Ok, done."
        MapNetworkDrive = True
        exit function
    end if

    errorMsg "Map network drive", "Cannot assign " & NetworkPath & " to " & DriveLetter

end function


private function MapUserDrive(DirToCheck)
    MapUserDrive = MapNetworkDrive(NetworkPath, UserDrive, DirToCheck, "user.id")
end function


private sub Testing_MapNetworkDrive
    MapNetworkDrive "\\notessrv\bill", "s:", "tmp", "anyfile.ext"
end sub


'----------------------------------------------------------------------
'
private function IsR5IniFile(IniFilename)
    debugMsg 40, "IsR5IniFile(1)", "IniFilename = """ & IniFilename & """"
    dim f, lines, pos, prevchar
    set f = fileSystem.OpenTextFile(IniFilename, ForReading)
    lines = f.readAll
    pos = InStr(1, lines, "Desktop5=", vbTextCompare)
    if pos = 0 then
        IsR5IniFile = false
        debugMsg 80, "IsR5IniFile(2)", "Has old format"
    elseif pos = 1 then
        IsR5IniFile = true
        debugMsg 80, "IsR5IniFile(3)", "Has R5 format"
    else
        prevchar = mid(lines, pos-1, 1)
        if (prevchar = chr(13)) or (prevchar = chr(10)) then
            IsR5IniFile = true
            debugMsg 80, "IsR5IniFile(4)", "Has R5 format"
        else
            IsR5IniFile = false
            debugMsg 80, "IsR5IniFile(5)", "Has old format"
        end if
    end if
end function


'----------------------------------------------------------------------
'
private function CreateMinimalistNotesIni(WhereDir, KeyFilename)
'...return full path of created NOTES.INI, "" = error
    debugMsg 40, "CreateMinimalistNotesIni", _
     "WhereDir = """ & WhereDir & """, KeyFilename = """ & KeyFilename & """"
    CreateMinimalistNotesIni = ""
    dim f, fname
    fname = WhereDir & "\NOTES.INI"
    set f = fileSystem.CreateTextFile(fname, True) '..true = overwrite
    f.WriteLine("[NOTES]")
    f.WriteLine("Directory=" & DataPath)
    f.WriteLine("PhoneLog=2")
    f.WriteLine("Log=log.nsf, 1, 0, 7, 40000")
    f.WriteLine("KeyFilename=" & KeyFilename)
    f.Close
    CreateMinimalistNotesIni = fname
    debugMsg 80, "CreateMinimalistNotesIni", fname
end function


'----------------------------------------------------------------------
'
private function SearchDocs(db, searchStr)  '...return NotesDocumentCollection
    set SearchDocs = nothing
    dim s, i, slen, c

    s = ""
    slen = len(searchStr)
    for i = 1 to slen
        c = mid(searchStr, i, 1)
        s = s & c
        if c = "\" then s = s & c
    next

    set SearchDocs = db.Search(s, nothing, 0)
end function


'----------------------------------------------------------------------
'
private function SetStartingLocation(IniFullpath, CanonicalUserName, location)
    debugMsg 40, "SetStartingLocation(1)", _
      "IniFullpath = """ & IniFullpath & """, CanonicalUserName = """ & CanonicalUserName & """"
    SetStartingLocation = false
    if not fileSystem.FileExists(IniFullpath) then
        errorMsg "SetStartingLocation", IniFullpath & " not found"
        exit function
    end if
    dim f, line
    set f = fileSystem.OpenTextFile(IniFullpath, ForAppending, False)
    line = "Location=" & _
           location.GetFirstItem("Name").Text & "," & _
           location.NoteID & "," & _
           CanonicalUserName
    debugMsg 40, "SetStartingLocation", "Location = """ & line & """"
    f.WriteLine ""
    f.WriteLine line
    f.Close
    debugMsg 40, "SetStartingLocation", "Done, ok."
end function


'----------------------------------------------------------------------
'
private function RunCommand(CmdLine, DirName, WindowStyle, WaitForReturn, DeleteShortcut)
'...return fullpath of created shortcut
    debugMsg 40, "RunCommand(1)", CmdLine & ", " & DirName & ", " & WindowStyle & ", " & WaitForReturn & ", " & DeleteShortcut
    RunCommand = ""
    dim lnkname, pifname, shortcut, pos, CmdName, CmdArgs, result

    pos = instr(1, CmdLine, " ")
    if pos = 0 then
        CmdName = CmdLine
        CmdArgs = ""
    else
        CmdName = Left(CmdLine, pos-1)
        CmdArgs = Mid(CmdLine, pos)
    end if

    lnkname = TempDir & "\runcmd.pif"
    if fileSystem.FileExists(lnkname) then fileSystem.DeleteFile(lnkname)
    lnkname = TempDir & "\runcmd.lnk"
    if fileSystem.FileExists(lnkname) then fileSystem.DeleteFile(lnkname)

    set shortcut = shell.CreateShortcut(lnkname)
    shortcut.TargetPath  = CmdName
    shortcut.Arguments   = CmdArgs
    shortcut.WindowStyle = WindowStyle
    shortcut.WorkingDirectory = DirName
    shortcut.Save
    lnkname = shortcut.FullName
    if not fileSystem.FileExists(lnkname) then
        lnkname = TempDir & "\runcmd.pif"
        if not fileSystem.FileExists(lnkname) then
            errorMsg "RunCommand", "Cannot create shortcut " & lnkname
            exit function
        end if
    end if
    debugMsg 20, "RunCommand(2)", "Created shortcut " & lnkname

    result = shell.Run(lnkname, WindowStyle, WaitForReturn)
    debugMsg 20, "RunCommand(3)", "Result = " & result

    if DeleteShortcut then
        if fileSystem.FileExists(lnkname) then fileSystem.DeleteFile(lnkname)
        debugMsg 20, "RunCommand(4)", lnkname & " deleted."
    end if

    RunCommand = lnkname
end function

private sub Testing_RunCommand
    WScript.echo "Result = " & RunCommand("subst.exe w: c:\temp", "c:\users", WindowMaximize, true, false)
end sub


'----------------------------------------------------------------------
'
private function ValidateIniFile(IniFilename, nsfPrefix, keyPrefix)

    dim result
    dim IniFile, attr
    dim pnabFilename
        pnabFilename = nsfPrefix & "names.nsf"
    dim srcIniFilename
        srcIniFilename = ScriptPath & "\notes.ini"
    dim pnabMustBeConverted
        pnabMustBeConverted = false

    debugMsg 40, "ValidateIniFile(1)", IniFilename & ", " & nsfPrefix & ", " & keyPrefix
    ValidateIniFile = false

    if fileSystem.FileExists(IniFilename) then
        debugMsg 80, "ValidateIniFile(2)", IniFilename & " exists"
        if IsR5IniFile(IniFilename) then
            debugMsg 80, "ValidateIniFile(3)", "INI file has R5 format"
            ValidateIniFile = true
            exit function
        else
            debugMsg 80, "ValidateIniFile(4)", "INI file has old format"
            pnabMustBeConverted = true
        end if
    end if
    '
    '  Create INI file: copy from template and add user-specific lines
    '
    debugMsg 80, "ValidateIniFile(5)", "Create " & IniFilename & " from " & srcIniFilename
    if not fileSystem.FileExists(srcIniFilename) then
        errorMsg "ValidateIniFile", srcIniFilename & " not exist!"
        exit function
    end if
    fileSystem.CopyFile srcIniFilename, IniFilename, true  '..overwrite

    ' Clear Read-Only attribute if present
    set IniFile = fileSystem.GetFile(IniFilename)
    attr = IniFile.attributes
    if attr and faReadOnly > 0 then _
      IniFile.attributes = attr and not faReadOnly

    set IniFile = fileSystem.OpenTextFile(IniFilename, ForAppending)

    IniFile.writeLine
    IniFile.writeLine "KeyFilename=" & keyPrefix & "user.id"
    IniFile.writeLine "Desktop5="    & nsfPrefix & "desktop5.dsk"
    IniFile.writeLine "NAMES="       & pnabFilename

    IniFile.Close

    if pnabMustBeConverted then
        '
        '  INI file already exists, but was in R4 format.
        '
        '  Convert existing Personal Address Book to R5 format.
        '
        '  8 = Displays the window in its current state.
        '      The active window remains active. 
        '
        if fileSystem.FileExists(pnabFilename) then
            dim nconvert, cmdline
            nconvert = BinPath & "\nconvert.exe"
            if not fileSystem.FileExists(nconvert) then
                errorMsg "Nconvert", "Program not found: " & nconvert
            else'
                '  Run NCONVERT.EXE under anonymous user.id
                '
                dim minIniFilename
                minIniFilename = CreateMinimalistNotesIni(TempDir, ScriptPath & "\anonymous.id")
                if minIniFilename = "" then
                    errorMsg "ValidateIniFile", "Cannot create temporary NOTES.INI"
                else
                    cmdline = nconvert & " " & pnabFilename & " StdR4PersonalAddressBook pernames.ntf"
                    debugMsg 80, "ValidateIniFile(6)", "Run " & cmdline & "..."
                    result = RunCommand(cmdline, TempDir, WindowActivate, RunWait, True)
                    debugMsg 40, "ValidateIniFile(7)", "Run = " & result
                    '??? check result
                    fileSystem.DeleteFile(minIniFilename)
                end if
            end if
        end if
    end if 'pnabMustBeConverted

    debugMsg 80, "ValidateIniFile(8)", "Done."
    ValidateIniFile = true

end function


private sub Testing_ValidateIniFile
    ValidateIniFile "c:\users\test\notes.ini", "c:\users\bill\", "c:\users\bill\"
end sub


'----------------------------------------------------------------------
'  CopyDontOverWrite
'
'  Example 1:
'  Input: "headline.nsf", "N:\Smith\"
'  Output: copy %ScriptPath%\headline.nsf to N:\Smith\headline.nsf
'
'  Example 2:
'  Input: "desktop5.dsk", "D:\Notes\Data\shared_"
'  Output: copy %ScriptPath%\desktop5.dsk to D:\Notes\Data\shared_desktop5.dsk
'
private function CopyDontOverWrite(isImportant, filename, srcFilepathPrefix, destFilepathPrefix)
    debugMsg 40, "CopyDontOverWrite(1)", filename & ", " & destFilepathPrefix
    CopyDontOverWrite = false
    dim srcFilename, destFilename
     srcFilename =  srcFilepathPrefix & filename
    destFilename = destFilepathPrefix & filename
    if fileSystem.FileExists(destFilename) then
        debugMsg 80, "CopyDontOverWrite(3)", destFilename & " already exists."
    elseIf not fileSystem.FileExists(srcFilename) then
        warningMsg "CopyDontOverWrite", filename & " not found"
        if isImportant then exit function
    else
        fileSystem.CopyFile srcFilename, destFilename
    end if
    CopyDontOverWrite = true
    debugMsg 40, "CopyDontOverWrite(4)", "Done, ok."
end function


'----------------------------------------------------------------------
'  ValidateUserFiles
'
'  Create all personal user files (except Windows shortcut)
'  using templates from %ScriptPath%:
'   1) notes.ini -- copy and fill by correct user-specific lines
'   2) *.nsf (names, headline, bookmark, perweb) -- just copy, don't patch
'   3) desktop5.dsk
'  USER.ID must be already present at destination place!
'
private function ValidateUserFiles(iniPrefix, srcPrefix, nsfPrefix, keyPrefix)
    ValidateUserFiles = false
    dim dummy, s
    s = keyPrefix & "user.id"
    if not fileSystem.FileExists(s) then
        errorMsg "ValidateUserFiles", "Cannot find """ & s & """"
        exit function
    end if
    if ValidateIniFile(iniPrefix & "notes.ini", nsfPrefix, keyPrefix) then _
    if CopyDontOverWrite(true, "names.nsf",    srcPrefix, nsfPrefix) then _
        ValidateUserFiles = true
    if CopyDontOverWrite(false, "desktop5.dsk", srcPrefix, nsfPrefix) then dummy=1
    if CopyDontOverWrite(false, "headline.nsf", srcPrefix, nsfPrefix) then dummy=1
    if CopyDontOverWrite(false, "bookmark.nsf", srcPrefix, nsfPrefix) then dummy=1
    if CopyDontOverWrite(false, "perweb.nsf",   srcPrefix, nsfPrefix) then dummy=1
end function

private sub Testing_ValidateUserFiles
    ValidateUserFiles "c:\users\test\", "c:\users\test\", "c:\users\test\"
end sub


'----------------------------------------------------------------------
'  UserLastName
'
'  Example:
'  Input: string with "Fox Mulder/WA/US@FBI" or "Fox B. Mulder"
'  Output: "Mulder"
'
private function UserLastName(CommonUserName)
    dim s, spacePos, nextSpacePos, slashPos, atPos, lastPos
    s = CommonUserName
    spacePos = InStr(s, " ")
    if spacePos > 0 then
        nextSpacePos = InStr(spacePos+1, s, " ")
        if nextSpacePos > 0 then spacePos = nextSpacePos
    end if
    slashPos = InStr(spacePos+1, s, "/")
    atPos    = InStr(spacePos+1, s, "@")
    if (slashPos = 0) and (atPos = 0) then
        lastPos = len(s)
    elseIf (slashPos > 0) and (atPos = 0) then
        lastPos = slashPos-1
    elseIf (slashPos = 0) and (atPos > 0) then
        lastPos = atPos-1
    elseIf (slashPos < atPos) then
        lastPos = slashPos-1
    else
        lastPos = atPos-1
    end if
    'WScript.echo "spacePos = " & spacePos & ", atPos = " & atPos & ", lastPos = " & lastPos
    s = mid(s, spacePos+1, lastPos-spacePos)
    UserLastName = s
end function

private sub Testing_UserLastName
    WScript.echo UserLastName("Fox Mulder/WA/US@FBI")
    WScript.echo UserLastName("Fox B. Mulder")
    WScript.echo UserLastName("Fox Mulder@FBI")
end sub


'----------------------------------------------------------------------
'  UserNameToMailFilename
'
'  Example1:
'  Input: "John Smith"
'  Output: "mail\jsmith"
'
'  Example2:
'  Input: "Aaron B. Chinatown"
'  Output: "mail\achinato"
'
private function UserNameToMailFilename(CommonUserName)
    UserNameToMailFilename = LCase("mail\" & _
        left(CommonUserName, 1) & _
        left(UserLastName(CommonUserName), 7))
end function


'----------------------------------------------------------------------
'
private function ValidateWindowsShortcut(CommonUserName, iniFullpath, lnkDirPrefix, readOnly)
'...return fullpath of created shortcut
    
    const CreatedNew     = 1
    const AlreadyExists  = 2
    const ModifyExisting = 3

    debugMsg 40, "ValidateWindowsShortcut(1)", CommonUserName & ", " & iniFullpath & ", " & lnkDirPrefix & ", " & readOnly
    ValidateWindowsShortcut = ""
    
    dim lnkFilename, lnkFullpath, lnkFile, shortcut, oldattrs
    dim state  '0 = ok, 1 = created new, 2 = modified
    
    lnkFilename = "Lotus Notes for " & Capitalize(UserLastName(CommonUserName)) & ".lnk"
    lnkFullpath = lnkDirPrefix & lnkFilename
    
    if fileSystem.FileExists(lnkFullpath) then
        debugMsg 40, "ValidateWindowsShortcut(2)", lnkFullpath & " already exists"
        state = AlreadyExists
    else
        debugMsg 40, "ValidateWindowsShortcut(2)", lnkFullpath & " will be created"
        state = CreatedNew
    end if

    set shortcut = shell.CreateShortcut(lnkFullpath)

    if state = CreatedNew then
                 shortcut.TargetPath  =        BinPath & "\notes.exe"
    elseIf UCase(shortcut.TargetPath) <> UCase(BinPath & "\notes.exe") then
        debugMsg 80, "ValidateWindowsShortcut", _
            "Update target path, old = """ & shortcut.TargetPath & _
            """, new = """ & BinPath & "\notes.exe" & """"
                 shortcut.TargetPath  =        BinPath & "\notes.exe"
        state = ModifyExisting
    end if
    
    if state = CreatedNew then
           shortcut.Arguments  = " =" & iniFullpath
    elseIf shortcut.Arguments <> " =" & iniFullpath then
           debugMsg 80, "ValidateWindowsShortcut", _
               "Update arguments, old = """ & shortcut.Arguments & """"
           shortcut.Arguments  = " =" & iniFullpath
           state = ModifyExisting
    end if

    shortcut.WindowStyle = WindowMaximize
    shortcut.WorkingDirectory = fileSystem.GetParentFolderName(lnkFullpath)

    ' Quick workaround for read-only filesystems
    err.clear
    on error resume next

    if state <> AlreadyExists then
        if state = ModifyExisting then
            set lnkFile = fileSystem.GetFile(lnkFullpath)
            lnkFile.Attributes = lnkFile.Attributes and not faReadOnly
            debugMsg 80, "ValidateWindowsShortcut(5)", "Clear read-only before saving."
        end if
        shortcut.Save
        debugMsg 40, "ValidateWindowsShortcut(4)", "Saved shortcut " & lnkFullpath
    end if

    if err.number <> 0 then warningMsg "ValidateWindowsShortcut", "Saving failed"
    err.clear

    if readOnly then
        set lnkFile = fileSystem.GetFile(lnkFullpath)
        oldattrs = lnkFile.Attributes
        if oldattrs and faReadOnly then
            debugMsg 80, "ValidateWindowsShortcut(5)", "Already read-only"
        else
            lnkFile.Attributes = oldattrs or faReadOnly
            debugMsg 80, "ValidateWindowsShortcut(5)", "Set read-only"
        end if
    end if

    if err.number <> 0 then warningMsg "ValidateWindowsShortcut", "Setting ReadOnly failed"

    ValidateWindowsShortcut = lnkFullpath

end function

private sub Testing_ValidateShortcut
    ValidateWindowsShortcut "Ivanov", "C:\users\test\notes.ini", "C:\Users\Test\", true
end sub


'----------------------------------------------------------------------
'  Start Lotus Notes session
'

private function TryToStartLotusNotes
    debugMsg 80, "TryToStartLotusNotes(1)", "Try..."
    on error resume next
    TryToStartLotusNotes = false
    set session = CreateObject("Notes.NotesSession")
    set workspace = CreateObject("Notes.NotesUIWorkspace")
    TryToStartLotusNotes = true
    debugMsg 80, "TryToStartLotusNotes(2)", "...Success"
end function


private function StartLotusNotes(ByCommand)

    debugMsg 40, "StartLotusNotes(1)", "ByCommand = " & ByCommand
    StartLotusNotes = false
    on error resume next

    if ByCommand <> "" then
        do
            dim i
            'debugMsg 20, "StartLotusNotes(2)", "Run = " & _
            shell.Run """" & ByCommand & """", WindowMaximize, RunDontWait
            i = sleepMsg(60, "Start Lotus Notes", "Press [Ok] button AFTER: " _
                & "a) Lotus Notes started, b) password accepted", _
                vbOkCancel + vbExclamation)
            if (i <> vbOk) and (i <> PopupTimeout) then
                errorMsg "StartLotusNotes", "Start Lotus Notes canceled by user"
                exit function
            end if
        loop while i = PopupTimeout
    end if

    do until TryToStartLotusNotes
        if AskBox("Cannot start Lotus Notes session. Try again?", vbYesNo+vbQuestion, _
          "Start Lotus Notes") <> vbYes then exit function
    loop

    debugMsg 40, "StartLotusNotes(4)", "Lotus Notes session created successfully"
    StartLotusNotes = true

end function


'----------------------------------------------------------------------
'
private function GetDnsName
   GetDnsName = ""
   debugMsg 80, "GetDnsName", "Start"
   const PacketSize = "13"
   dim cmd, filename, st, line, bracketPos, spacepos
   filename = TempDir & "\ping.log"
   cmd = Environment("COMSPEC") & " /c ping -n 1 -l " & PacketSize & " localhost > " & filename
   debugMsg 40, "GetDnsName", "Command = """ & cmd & """"
   shell.Run cmd, WindowMinimizeDontGrabFocus, RunWait
   if not fileSystem.FileExists(filename) then
      debugMsg 10, "GetDnsName", filename & " not found!"
   else
      set st = fileSystem.GetFile(filename).OpenAsTextStream
      do while not st.AtEndOfStream
         line = st.ReadLine
         'debugMsg 99, "GetDnsName", "Line = """ & line & """"
         if instr(1, line, PacketSize) > 0 then
            'debugMsg 99, "GetDnsName", PacketSize & " found"
            bracketPos = instr(1, line, "[")
            if bracketPos > 2 then
               'debugMsg 99, "GetDnsName", "Bracket found at " & bracketPos
               spacepos = instrRev(line, " ", bracketpos-2)
               if spacepos > 0 then
                  'debugMsg 99, "GetDnsName", "Space found at " & spacePos
                  line = mid(line, spacepos+1, bracketpos-2-spacepos)
                  debugMsg 20, "GetDnsName", "Result = """ & line & """"
                  GetDnsName = line
                  exit function
               end if
            end if
         end if
      loop
   end if
end function

private function GetDnsDomain
   GetDnsDomain = ""
   dim s, pointPos
   s = GetDnsName
   pointPos = instr(1, s, ".")
   if pointPos > 0 then s = mid(s, pointPos+1, len(s))
   debugMsg 40, "GetDnsDomain", "Result = """ & s & """"
   GetDnsDomain = s
end function

private function DominoAddrToIpAddr(DominoAddr)
    debugMsg 40, "DominoAddrToIpAddr(1)", DominoAddr
    dim addr, i, addrlen, ch
    addr = ""
    addrlen = len(DominoAddr)
    for i = 1 to addrlen
        ch = mid(DominoAddr, i, 1)
        if ch = "/" then
            ch = "."
        elseIf ch = "@" then
            exit for
        else
            ch = lcase(ch)
        end if
        addr = addr & ch
    next
    debugMsg 80, "DominoAddrToIpAddr(2)", "Result = """ & addr & """"
    DominoAddrToIpAddr = addr
end function

private function IpAddrToDominoAddr(IpAddr)
    debugMsg 40, "IpAddrToDominoAddr(1)", IpAddr
    dim addr, i, addrlen, ch
    addr = ""
    addrlen = len(IpAddr)
    for i = 1 to addrlen
        ch = mid(IpAddr, i, 1)
        if ch = "." then ch = "/"
        addr = addr & ch
    next
    debugMsg 80, "IpAddrToDominoAddr(2)", "Result = """ & addr & """"
    IpAddrToDominoAddr = ucase(addr)
end function

private function DominoNameToLocationName(DominoName)
   DominoNameToLocationName = ""
   debugMsg 40, "DominoNameToLocationName", "Domino server name = " & DominoName
   dim s, slash1pos, slash2pos
   slash1pos = instr(1, DominoName, "/")
   if slash1pos = 0 then
      debugMsg 20, "DominoNameToLocationName", "First slash not found"
      s = DominoName
   else
      s = left(DominoName, slash1pos-1)
      if lcase(s) = "notessrv" then
         slash2pos = instr(slash1pos+1, DominoName, "/")
         if slash2pos = 0 then
            debugMsg 20, "DominoNameToLocationName", "Second slash not found"
            s = mid(DominoName, slash1pos+1, len(DominoName))
         else
            s = mid(DominoName, slash1pos+1, slash2pos - slash1pos - 1)
         end if
      end if
   end if
   debugMsg 40, "DominoNameToLocationName", "Result = """ & s & """"
   DominoNameToLocationName = s
end function

private sub Testing_DominoAddrToIpAddr
   'WScript.echo "DominoAddrToIpAddr = """ & DominoAddrToIpAddr("NotesSrv/SPb05/UCVT/RU@UCVT") & """"
   'WScript.echo         "GetDnsName = """ & GetDnsName & """"
   'WScript.echo       "GetDnsDomain = """ & GetDnsDomain & """"
   'WScript.echo "IpAddrToDominoAddr = """ & IpAddrToDominoAddr("notessrv.spb05.ucvt.ru") & """"
    WScript.echo   "DomNameToLocName = """ & DominoNameToLocationName("NotesSrv/SPb05/UCVT/RU") & """"
    WScript.echo   "DomNameToLocName = """ & DominoNameToLocationName("ESpace/UCVT/RU") & """"
    WScript.echo   "DomNameToLocName = """ & DominoNameToLocationName("NotesSrv") & """"
    WScript.echo   "DomNameToLocName = """ & DominoNameToLocationName("NotesSrv/UCVT") & """"
end sub


'----------------------------------------------------------------------
'
private function ValidateItem(doc, itemName, newValue, isNewDoc)
    ValidateItem = false
    dim item
    if not isNewDoc then
        set item = doc.GetFirstItem(itemName)
        if LCase(item.Text) = LCase(newValue) then exit function
        debugMsg 60, "ValidateItem", "Replace " & itemName & _
          ": old = """ & item.Text & """, new = """ & newValue & """"
    end if
    doc.ReplaceItemValue itemName, newValue
    ValidateItem = true
end function

'----------------------------------------------------------------------
'
private function ValidateLocation(pnab, locname, OnlyForUsername, _
                                  MailServer, MailFile, nsfPrefix, keyPrefix)
'...return created or found NotesDocument
    debugMsg 40, "ValidateLocation(1)", locname & ", " & OnlyForUsername & ", " & MailServer & ", " & MailFile & ", " & nsfPrefix & ", " & keyPrefix
    set ValidateLocation = Nothing

    dim docs, location, searchStr, keyFilename, isNewDoc, isChanged, CanonicalUserName

    keyFilename = keyPrefix & "user.id"

    searchStr = "(Form = ""Location"") & " & _
        "(LocationType = ""0"") & " & _
                "(Name = """ & locname & """)"

    debugMsg 80, "ValidateLocation(2)", "Search " & searchStr & "..."
    set docs = SearchDocs(pnab, searchStr)
    debugMsg 40, "ValidateLocation(3)", "Found " & docs.Count & " docs"
    
    if docs.count > 0 then
        set location = docs.GetFirstDocument
        set ValidateLocation = location
        debugMsg 80, "ValidateLocation(4)", "Found existing location: """ & locname & """, " & location.NoteID
        isNewDoc = false
        isChanged = false
    else
        set location = pnab.CreateDocument
        if location is nothing then
            errorMsg "ValidateLocation", "Cannot create new location document"
            exit function
        end if
        debugMsg 80, "ValidateLocation(4)", "Created new location: """ & locname & """"
        isNewDoc = true
        isChanged = true
    end if
    if ValidateItem(location, "Form",       "Location" , isNewDoc) then isChanged = true
    if ValidateItem(location, "Name",       locname    , isNewDoc) then isChanged = true
    if ValidateItem(location, "MailServer", _
              session.CreateName(MailServer).Canonical , isNewDoc) then isChanged = true
    if ValidateItem(location, "MailFile",   MailFile   , isNewDoc) then isChanged = true
    if ValidateItem(location, "LocationType","0"       , isNewDoc) then isChanged = true  '...0 = LAN
    if ValidateItem(location, "MailType",   "0"        , isNewDoc) then isChanged = true  ' mail file location = On Server
    if ValidateItem(location, "UserID",     keyFilename, isNewDoc) then isChanged = true
    if ValidateItem(location, "UseOSTz",    "1"        , isNewDoc) then isChanged = true
  ''if ValidateItem(location, "WebRetriever",   "0"    , isNewDoc) then isChanged = true
    if ValidateItem(location, "BookmarkDb", nsfPrefix & "bookmark.nsf", isNewDoc) then isChanged = true
    if ValidateItem(location, "HeadlineDb", nsfPrefix & "headline.nsf", isNewDoc) then isChanged = true
    if ValidateItem(location, "WebDbName",  nsfPrefix & "perweb.nsf"  , isNewDoc) then isChanged = true
    if ValidateItem(location, "Domain",     ""                        , isNewDoc) then isChanged = true

    if OnlyForUserName <> "" then
        CanonicalUserName = session.CreateName(OnlyForUserName).Canonical
        if ValidateItem(location, "Source", CanonicalUserName, isNewDoc) then isChanged = true
    else
        ''CanonicalUserName = session.CreateName(session.UserName).Canonical
        if ValidateItem(location, "Source", "*", isNewDoc) then isChanged = true
    end if

    if isChanged then
        if not location.ComputeWithForm(false, false) then
            errorMsg "ValidateLocation", "ComputeWithForm failed: " & locname
            exit function
        end if
    
        if not location.Save(true, false) then
            errorMsg "ValidateLocation", "docSave failed: " & locname
            exit function
        end if

        debugMsg 20, "ValidateLocation(5)", "Saved location: """ & locname & """, " & location.NoteID
    else
        debugMsg 60, "ValidateLocation(5)", "Location still unchanged"
    end if

    debugMsg 40, "ValidateLocation(6)", "Done"
    set ValidateLocation = location
end function


'----------------------------------------------------------------------
'  ValidateConnection
'
'  Find or create LAN connection to given Domino server using given network
'  address (for given location only) in given Personal Address Book.
'
'  Return connection object (found or created)
'
private function ValidateConnection(pnab, ServerName, ServerAddress, locationName)

    debugMsg 40, "ValidateConnection(1)", ServerName & ", " & ServerAddress & ", " & locationName
    set ValidateConnection = nothing

    dim docs, connection, SearchStr, netaddr

    SearchStr =        "((Form = ""Connection"")           | " & _
                        "(Form = ""local""))               & " & _
              "(ConnectionType = ""0"")                    & " & _
         "((ConnectionLocation = """ & locationName & """) | " & _
         " (ConnectionLocation = ""*""))                   & " & _
     "(@UpperCase(@Name([Abbreviate]; Destination)) = """ & UCase(ServerName) & """) & " & _
     "@Contains(LanPortName;""" & LanPortName & """)"

    set docs = SearchDocs(pnab, SearchStr)
    debugMsg 80, "ValidateConnection(2)", "Found " & docs.Count & " docs."

    if docs.Count > 0 then

        set connection = docs.GetFirstDocument
        set ValidateConnection = connection
        debugMsg 80, "ValidateConnection(2)", "NoteID = " & connection.NoteID

        set netaddr = connection.GetFirstItem("OptionalNetworkAddress")
        if netaddr is nothing then
            debugMsg 90, "ValidateConnection(3)", _
              "Missing OptionalNetworkAddress field"
            connection.ReplaceItemValue "OptionalNetworkAddress", ServerAddress
        elseIf netaddr.text <> ServerAddress then
            debugMsg 80, "ValidateConnection(3)", _
              "Replace old address = " & netaddr.text
            connection.ReplaceItemValue "OptionalNetworkAddress", ServerAddress
        end if

    else

        set connection = pnab.CreateDocument
        if connection is nothing then
            errorMsg "ValidateConnection", "Cannot create connection document"
            exit function
        end if

        connection.ReplaceItemValue "Form",                   "local"
        connection.ReplaceItemValue "Type",                   "Connection"
        connection.ReplaceItemValue "ConnectionType",         "0"
        connection.ReplaceItemValue "ConnectionLocation",     "*"
        connection.ReplaceItemValue "Destination",            ServerName
        connection.ReplaceItemValue "OptionalNetworkAddress", ServerAddress
        connection.ReplaceItemValue "LanPortName",            LanPortName

        if not connection.ComputeWithForm(false, false) then
            errorMsg "ValidateConnection", "Cannot compute connection document with form"
            exit function
        end if
    
        if not connection.Save(true, false) then
            errorMsg "ValidateConnection", "Cannot save connection document"
            exit function
        end if

        set ValidateConnection = connection
        debugMsg 80, "ValidateConnection(5)", "Saved document NoteID = " & connection.NoteID

    end if 'not (docs.Count > 0)

end function


'----------------------------------------------------------------------
'  ValidateMailFilename
'
'  Set contents of "MailFile" field in given location document
'  to the same value as in person document of given user
'
private function ValidateMailFilename(session, AbbrevUserName, location)

    debugMsg 80, "ValidateMailFilename", "Start"
    ValidateMailFilename = false

    dim abook, peopleView, personDoc, MailFilename
    dim accessLevel, maxAccessLevel   '0=no access, 1=depositor, 2=reader,... 6=manager

    debugMsg 40, "ValidateMailFilename", AbbrevUserName & ", " & location.GetFirstItem("Name").Text
    maxAccessLevel = 0

    on error resume next  '..intercept possible session.AddressBooks failure
    for each abook in session.AddressBooks
    do
        debugMsg 80, "ValidateMailFilename", "Address book: " & abook.Filename & ", " & abook.Server
        if not abook.IsPublicAddressBook then
            debugMsg 80, "ValidateMailFilename", "Is not public, skipped."
            exit do
        end if
        if not abook.IsOpen then abook.Open "", ""
        if not abook.IsOpen then
            debugMsg 40, "ValidateMailFilename", "Cannot open " & abook.Filename & ", " & abook.Server
            exit do
        end if
        accessLevel = abook.CurrentAccessLevel
        if accessLevel > maxAccessLevel then maxAccessLevel = accessLevel
        if accessLevel < 2 then  '2 = reader
            warningMsg "ValidateMailFilename", "Our access level to " _
                & abook.Filename & ", " & abook.Server & " = " & accessLevel
            exit do
        end if
        debugMsg 90, "ValidateMailFilename", "Our access level to " _
            & abook.Filename & ", " & abook.Server & " = " & accessLevel
        set peopleView = abook.GetView("($VIMPeople)")
        if peopleView is nothing then
            debugMsg 10, "ValidateMailFilename", "($VIMPeople) view not found!"
            exit do
        end if
        set personDoc = peopleView.GetDocumentByKey(abbrevUserName, true)  '..exact match
        if personDoc is nothing then
            debugMsg 80, "ValidateMailFilename", "Person not found in this address book"
            exit do
        end if
        debugMsg 40, "ValidateMailFilename", "Person FOUND in this address book"
        if not personDoc.HasItem("MailFile") then
            debugMsg 10, "ValidateMailFilename", "Person without MailFile item"
            exit do
        end if
        
        MailFilename = personDoc.GetFirstItem("MailFile").Text
        debugMsg 80, "ValidateMailFilename", "Person mailfile = " & MailFilename
        
        if not location.HasItem("MailFile") then
            debugMsg 10, "ValidateMailFilename", "Location without MailFile item"
        elseIf location.GetFirstItem("MailFile").Text = MailFilename then
            debugMsg 20, "ValidateMailFilename", "MailFile fields are equal"
            ValidateMailFilename = true
            exit function
        end if
        
        location.ReplaceItemValue "MailFile", MailFilename
        debugMsg 20, "ValidateMailFilename", "Replace MailFile field"
        
        if not location.Save(true, false) then
            errorMsg "ValidateMailFilename", "Cannot save location"
            exit function
        end if
        
        ValidateMailFilename = true
        debugMsg 20, "ValidateMailFilename", "Done, ok"
        exit function
            
    loop until true
    next 'for each abook in session.AddressBooks

    if maxAccessLevel < 2 then    '2 = reader
        debugMsg 99, "ValidateMailFilename", "MaxAccessLevel = " & MaxAccessLevel
        errorMsg "ValidateMailFilename", _
          AbbrevUserName & " dont have appropriate access rights to any Address Book!"
    else
        errorMsg "ValidateMailFilename", _
          AbbrevUserName & " not found in Address Books!"
    end if

    debugMsg 99, "ValidateMailFilename", "Done, failed."

end function


'----------------------------------------------------------------------
'
private function ValidateMailDb(session, location)
    ValidateMailDb = false
    dim maildb, server, filename, docItem
    debugMsg 60, "ValidateMailDb", _
      "Find mail database for location with NoteID = " & location.NoteID

    set docItem = location.GetFirstItem("MailServer")
    if docItem is nothing then
        warningMsg "ValidateMailDb", "Invalid location: no MailServer field"
        exit function
    end if
    server = docItem.text

    set docItem = location.GetFirstItem("MailFile")
    if docItem is nothing then
        warningMsg "ValidateMailDb", "Invalid location: no MailFile field"
        exit function
    end if
    filename = docItem.text

    set maildb = session.GetDatabase(server, filename, false)  'don't create if not exists
    if not maildb.IsOpen then
        errorMsg "ValidateMailDb", "Mail database NOT found: " _
          & filename & ", " & server
        exit function
    end if

    if maildb.CurrentAccessLevel < 3 then  '3 = Author
        errorMsg "ValidateMailDb", "Inadequate access rights to " _
          & filename & ", " & server & " = " & maildb.CurrentAccessLevel
        exit function
    end if

    debugMsg 60, "ValidateMailDb", "Mail database found: " & filename & ", " & server
    ValidateMailDb = true
end function


'----------------------------------------------------------------------
'
private function AddNotesShortcuts(session, workspace, MailServer, MailFile, nsfPrefix)
    AddNotesShortcuts = false
    ' We need no check because we are here after ValidateMailDb:
    ' we know that MailDb actually exists
    workspace.AddDatabase MailServer, MailFile
    if fileSystem.FileExists(nsfPrefix & "names.nsf"   ) then workspace.AddDatabase "", nsfPrefix & "names.nsf"
    if fileSystem.FileExists(nsfPrefix & "bookmark.nsf") then workspace.AddDatabase "", nsfPrefix & "bookmark.nsf"
    if fileSystem.FileExists(nsfPrefix & "headline.nsf") then workspace.AddDatabase "", nsfPrefix & "headline.nsf"
    if fileSystem.FileExists(nsfPrefix & "perweb.nsf"  ) then workspace.AddDatabase "", nsfPrefix & "perweb.nsf"
    AddNotesShortcuts = true
end function


'----------------------------------------------------------------------
'
private function ValidateDatabaseACL(session, dbFullpath, AbbrevUserName, MailServer)
    ValidateDatabaseACL = false
    debugMsg 80, "ValidateDatabaseACL(1)", dbFullpath & ", " & AbbrevUserName & ", " & MailServer
    dim db
    set db = session.GetDatabase("", dbFullpath, false)  '..don't create on fail
    if not (db is nothing) then
        if db.IsOpen then
            debugMsg 99, "ValidateDatabaseACL(2)", "Open ok, try to change ACL"
            db.GrantAccess AbbrevUserName, 6       '..Manager
            db.GrantAccess MailServer, 6           '..Manager
            db.RevokeAccess "LocalDomainAdmins"
            db.RevokeAccess "LocalDomainServers"
            db.RevokeAccess "OtherDomainServers"
            ValidateDatabaseACL = true
            debugMsg 90, "ValidateDatabaseACL(3)", "Done"
            exit function
        end if
    end if
    warningMsg "ValidateDatabaseACL", _
       "Cannot open database """ & dbFullpath & """"
end function


'----------------------------------------------------------------------
'
private function ValidateDatabasesACL(session, nsfPrefix, AbbrevUserName, MailServer)
    ValidateDatabasesACL = false
    if ValidateDatabaseACL(session, nsfPrefix & "names.nsf"   , AbbrevUserName, MailServer) then _
      ValidateDatabasesACL = true
    call ValidateDatabaseACL(session, nsfPrefix & "headline.nsf", AbbrevUserName, MailServer)
    call ValidateDatabaseACL(session, nsfPrefix & "bookmark.nsf", AbbrevUserName, MailServer)
    call ValidateDatabaseACL(session, nsfPrefix & "perweb.nsf"  , AbbrevUserName, MailServer)
end function


'----------------------------------------------------------------------
'
private sub Testing_ValidateAll

   'if not StartLotusNotes("c:\users\bill\Lotus Notes for bill.lnk") then
    if not StartLotusNotes("") then
        errorMsg "Testing_ValidateAll", "Cannot start Notes session"
        exit sub
    end if
    debugMsg 10, "Testing_ValidateAll", "Session start ok"

    dim pnab
    set pnab = session.GetDatabase("", "n:\bill\names", false)
    if not pnab.IsOpen then pnab.Open "",""
    if not pnab.IsOpen then
        errorMsg "Testing_ValidateAll", "Cannot open database"
        exit sub
    end if
    debugMsg 10, "Testing_ValidateAll", "PNAB open ok"

    dim location
    set location = ValidateLocation(pnab, "ValidLoc", _
        "Alfreddy Krueger/UCVT/RU", "SubSpace/UCVT/RU", _
        "mail\akrueger", "c:\users\test\", "c:\users\test\")
    if location is nothing then
        errorMsg "Testing_ValidateAll", "ValidateLocation failed"
        exit sub
    end if
    debugMsg 10, "Testing_ValidateAll", "ValidateLocation ok"

    if ValidateConnection(pnab, "SubSpace/UCVT/RU", "10.10.1.110", _
                          "ValidLoc") is nothing then
        errorMsg "Testing_ValidateAll", "ValidateConnection failed"
        exit sub
    end if
    debugMsg 10, "Testing_ValidateLocation", "ValidateConnection ok"

    if not ValidateMailFilename(session, session.CreateName(session.UserName).Abbreviated, location) then
        errorMsg "Testing_ValidateAll", "ValidateMailFilename"
        exit sub
    end if
    debugMsg 10, "Testing_ValidateAll", "ValidateMailFilename ok"

end sub


'----------------------------------------------------------------------
'
private sub DoPerson(pnab, AbbrevUserName)
    dim Lastname, LocalUserDirPrefix, MainUserDirPrefix, SharedPrefix
    dim iniPrefix, keyPrefix, nsfPrefix, iniFullpath
    
    Lastname           = UserLastName(AbbrevUserName)
    MainUserDirPrefix  = "N:\" & LastName & "\"
    LocalUserDirPrefix = DataPath & "\Users\" & LastName & "\"
    SharedPrefix       = DataPath & "\shared_"

    nsfPrefix = SharedPrefix
    iniPrefix = LocalUserDirPrefix
    keyPrefix = MainUserDirPrefix
    iniFullpath = LocalUserDirPrefix & "NOTES.INI"

    dim location
    set location = ValidateLocation(pnab, Lastname, _
        AbbrevUserName, "SubSpace/UCVT/RU", _
        UserNameToMailFilename(AbbrevUserName), _
        nsfPrefix, keyPrefix)
    if location is nothing then
        errorMsg "Testing_ValidateAll", "ValidateLocation failed"
        exit sub
    end if

    call ValidateConnection(pnab, "SubSpace/UCVT/RU", "10.10.1.110", Lastname)
    call ValidateMailFilename(session, AbbrevUserName, location)
    call ValidateWindowsShortcut(AbbrevUserName, IniFullpath, LocalUserDirPrefix, false)
    call ValidateIniFile(IniFullpath, nsfPrefix, keyPrefix)
    call SetStartingLocation(IniFullPath, AbbrevUsername, location)

end sub


private sub RegisterRoustavelyTeachers
    ScriptPath = "c:\users\evseev\init5"
    msgboxDebugLevel = 10

    if not StartLotusNotes("") then
        errorMsg "RegisterRoustavelyUsers", "Cannot start Notes session"
        exit sub
    end if

    dim pnab
    set pnab = session.GetDatabase("", "d:\notes\data\shared_names", false)
    if not pnab.IsOpen then pnab.Open "",""
    if not pnab.IsOpen then
        errorMsg "RegisterRoustavelyTeachers", "Cannot open database"
        exit sub
    end if

    DoPerson pnab, "Irina V. Kochneva/Teachers/SPb01/UCVT/RU"
    DoPerson pnab, "Igor B. Alexeev/Teachers/Tosno01/UCVT/RU"
    DoPerson pnab, "Irina V. Alexeeva/Teachers/SPb01/UCVT/RU"
    DoPerson pnab, "Sergey A. Chukhonin/Teachers/SPb01/UCVT/RU"
    DoPerson pnab, "Alexey V. Nikitin/Teachers/SPb01/UCVT/RU"
    DoPerson pnab, "Boris A. Karpichev/Teachers/SPb01/UCVT/RU"
    DoPerson pnab, "Natalia A. Rybina/Teachers/SPb03/UCVT/RU"

    debugMsg 1, "RegisterRoustavelyUsers", "All done"
end sub


'----------------------------------------------------------------------
'
private function ParseOption(argStr)
    dim seppos, n, v
    ParseOption = false
    debugMsg 40, "ParseOption", """" & argStr & """"
    seppos = instr(1, argStr, "=")
    if seppos = 0 then seppos = instr(1, argStr, ":")
    if seppos = 0 then
        infoMsg "ParseOption", """" & argStr & """ does not contain ""="" nor "":"""
        n = argStr
        v = ""
    else
        n = left(argStr, seppos-1)
        v = right(argStr, len(argStr)-seppos)
    end if
    debugMsg 80, "ParseOption", "name = """ & n & """, value = """ & v & """"
    n = lcase(n)
  
    if n = lcase("Debug") then
        FileDebugLevel = cint(v)
        MsgDebugLevel  = cint(v)
    elseIf n = lcase("FileDebug") then
        FileDebugLevel = cint(v)      
    elseIf n = lcase("MsgDebug") then
        MsgDebugLevel  = cint(v)
    elseIf n = lcase("EndMsg") then
        ShowEndMsg = true
    elseIf n = lcase("UserLogin") then
        UserLogin = v
    elseIf n = lcase("UserName") then
        UserName  = v
    elseIf n = lcase("DirName") then
        DirName  = v
    elseIf n = lcase("LocalDir") then
        LocalUserDir = v
    elseIf n = lcase("UserDir") then
        NetworkUserDir = v
    elseIf n = lcase("NetworkPath") then
        NetworkPath = v
    elseIf n = lcase("DistribPath") then
        DistribPath = v
    elseIf n = lcase("DominoServer") then
        DominoServer = v
    elseIf n = lcase("IPAddr") then
        DominoServerIPAddr = v
    elseIf n = lcase("ScriptPath") then
        ScriptPath = v
    elseIf n = lcase("winlnk") then
        if lcase(v) = "yes" then
            AddDesktopShortcut = vbYes
        elseIf lcase(v) = "no" then
            AddDesktopShortcut = vbNo
        elseIf lcase(v) = "ask" then
            AddDesktopShortcut = vbRetry  'ask user
        else
            errorMsg "ParseOption", "Unknown ""winlnk"" value = """ & v & """"
        end if
    elseIf n = lcase("Mode") or n = lcase("Install") then
        if     lcase(v) = "local" then
            InstallMode = InstallLocal
        elseIf lcase(v) = "network" then
            InstallMode = InstallNetwork
        elseIf lcase(v) = "shared" then
            InstallMode = InstallSharedLocal
        elseIf lcase(v) = "lshared" then
            InstallMode = InstallSharedLocalID
        elseIf lcase(v) = "program" then
            InstallMode = InstallProgramOnly
        else
            errorMsg "ParseOption", "Unknown InstallMode value """ & v & """"
            exit function
        end if
    else
        errorMsg "ParseOption", "Unknown option """ & Capitalize(n) & """"
        exit function
    end if
  
    ParseOption = true
  
end function


private function ParseCommandLine
   ParseCommandLine = false
   dim args, i, ok
   set args = WScript.Arguments
   for i = 0 to args.Count - 1
      if not ParseOption(args(I)) then exit function
   next

   if isempty(UserLogin) then
      UserLogin = safeRegistryRead("HKLM\Network\Logon\username", ok)
      if UserLogin = "" then
         errorBox "ParseOption", "Cannot detect UserLogin"
         exit function
      end if
   end if

   if DirName        = "" then DirName = UserLogin
   if LocalUserDir   = "" then LocalUserDir   = DataPath & "\Users\" & DirName
   if NetworkUserDir = "" then NetworkUserDir =      UserDrive & "\" & DirName
   if DominoServer   = "" then DominoServer   = IpAddrToDominoAddr(nbDominoServer & "." & GetDnsDomain)
   if DominoServerIPAddr = "" then DominoServerIPAddr = DominoAddrToIpAddr(DominoServer)

   ' are initialized above: NetworkPath, ScriptPath

   ParseCommandLine = true
end function

private sub Testing_ParseCommandLine
   dim v
   v = ParseCommandLine
   infoMsg "Testing_ParseCommandLine", "ParseCommandLine = " & cstr(v)

   if v then
      infoMsg "Testing_ParseCommandLine", "UserLogin          = """ & UserLogin          & """"
      infoMsg "Testing_ParseCommandLine", "UserName           = """ & UserName           & """"
      infoMsg "Testing_ParseCommandLine", "DirName            = """ & DirName            & """"
      infoMsg "Testing_ParseCommandLine", "LocalUserDir       = """ & LocalUserDir       & """"
      infoMsg "Testing_ParseCommandLine", "NetworkUserDir     = """ & NetworkUserDir     & """"
      infoMsg "Testing_ParseCommandLine", "NetworkPath        = """ & NetworkPath        & """"
      infoMsg "Testing_ParseCommandLine", "DominoServer       = """ & DominoServer       & """"
      infoMsg "Testing_ParseCommandLine", "DominoServerIPAddr = """ & DominoServerIPAddr & """"
      infoMsg "Testing_ParseCommandLine", "ScriptPath         = """ & ScriptPath         & """"
      infoMsg "Testing_ParseCommandLine", "InstallMode        = " & InstallMode        
   end if
end sub


'----------------------------------------------------------------------
'
private function Main

   Main = false

   if not InitTempDir then
       msgbox "Cannot create temporary folder", vbOkOnly+vbCritical, "Init5.vbs"
       exit function
   end if

   if not ParseCommandLine then exit function

   if not ValidateNotes then exit function
   if InstallMode = InstallProgramOnly then
       MapNetworkDrive NetworkPath, UserDrive, "", ""
       if ShowEndMsg then AskBox "Installation done.", vbOkOnly, "init5.vbs"
       Main = true
       exit function
   end if

   dim nsfPrefix, iniPrefix, keyPrefix, iniFullpath, lnkFullpath, locnameSuffix
   locnameSuffix = ""

   select case InstallMode
      case InstallLocal
      case InstallSharedLocalId
      case else
         if not MapUserDrive(DirName) then exit function
   end select

   if InstallMode <> InstallNetwork then _
    if not ValidateFolder(LocalUserDir, True) then _
     exit function

   select case InstallMode
      case InstallLocal
         keyPrefix = LocalUserDir   & Slash
         iniPrefix = keyPrefix
         nsfPrefix = keyPrefix
         locnameSuffix = " (Local)"
      case InstallSharedLocal
         keyPrefix = NetworkUserDir & Slash
         iniPrefix = LocalUserDir   & Slash
         nsfPrefix = DataPath       & Slash & "shared_"
         locnameSuffix = " (Shared_local)"
      case InstallSharedLocalId
         keyPrefix = LocalUserDir   & Slash
         iniPrefix = keyPrefix
         nsfPrefix = DataPath       & Slash & "shared_"
         locnameSuffix = " (Shared_local_ID)"
      case InstallNetwork
         keyPrefix = NetworkUserDir & Slash
         iniPrefix = keyPrefix
         nsfPrefix = keyPrefix
         locnameSuffix = " (Full_network)"
   end select

   iniFullPath = iniPrefix & "NOTES.INI"

   ' Copy template files to user folder, create NOTES.INI
   if not ValidateUserFiles(iniPrefix, ScriptPath & Slash, nsfPrefix, keyPrefix) then exit function

   lnkFullPath = ValidateWindowsShortcut(UserLogin, iniFullpath, iniPrefix, true)
   if lnkFullpath = "" then exit function

   if AddDesktopShortcut = vbRetry then
       AddDesktopShortcut = AskBox("Add shortcut to Windows desktop?", _
         vbYesNo + vbQuestion, "init5.vbs")
   end if
   if AddDesktopShortcut = vbYes then
       if ValidateWindowsShortcut(UserLogin, iniFullpath, _
         safeRegistryRead("HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Desktop", ok) _
           & Slash, false) = "" _
       then exit function
   else
       debugMsg 80, "AddDesktopShortcut", "skipped."
   end if

   if UserName <> "" then lnkFullpath = ""   ' attach to already running instance of Lotus Notes
   if not StartLotusNotes(lnkFullpath) then exit function

   dim pnab, location, locname, OnlyForUserName, locationMustBeSwitched

   if UserName = "" then
      UserName = session.CreateName(session.UserName).Abbreviated
      locationMustBeSwitched = true
   else
      locationMustBeSwitched = false
   end if

   if (InstallMode = InstallSharedLocal) or (InstallMode = InstallSharedLocalID) then
      locname = Capitalize(UserLastName(UserName)) + locnameSuffix
      OnlyForUserName = UserName
   else
      locname = DominoNameToLocationName(DominoServer) + locnameSuffix
      OnlyForUserName = ""
   end if

   set pnab = session.GetDatabase("", nsfPrefix & "names.nsf", false)
   if pnab is nothing then
      errorMsg "Main", "Cannot get """ & nsfPrefix & "names.nsf" & """"
      exit function
   end if

   set location = ValidateLocation(pnab, locname, OnlyForUsername, _
      DominoServer, UserNameToMailFilename(UserName), nsfPrefix, keyPrefix)

   if location is nothing then exit function

   call SetStartingLocation(iniFullpath, _
      session.CreateName(UserName).Canonical, location)

   if ValidateConnection(pnab, DominoServer, DominoServerIPAddr, locname) is nothing then exit function

   if locationMustBeSwitched then
      debugMsg 60, "Main", "Switch to location """ & locname & """"
      call workspace.SetCurrentLocation(locname)
   end if

   if not ValidateMailFilename(session, UserName, location) then exit function

   if not ValidateMailDb(session, location) then exit function

   if not ValidateDatabasesACL(session, nsfPrefix, UserName, DominoServer) then exit function

   if locationMustBeSwitched then _
     if not AddNotesShortcuts(session, workspace, _
       location.GetFirstItem("MailServer").Text, _
       location.GetFirstItem("MailFile").Text, _
       nsfPrefix) _
     then exit function

   infoMsg "Main", "Done"
   if ShowEndMsg then AskBox "Initialization done.", vbOkOnly, "init5.vbs"
   Main = true
   
end function


'----------------------------------------------------------------------

Main

'ValidateNotes
'Testing_MapNetworkDrive
'Testing_RunCommand
'Testing_ValidateIniFile
'Testing_ValidateUserFiles
'Testing_UserLastName
'Testing_ValidateShortcut
'Testing_DominoAddrToIpAddr
'Testing_ValidateAll
'Testing_ParseCommandLine
'RegisterRoustavelyTeachers

'<<EOF>>
