@echo off
::
::  SetPerms.bat
::
::  Set right permissions to data directory of one Notes user
::
::  Works only under WinNT only on NTFS partition
::  Requires XCACLS.EXE from NT Resource Kit
::
::  How to set permissions for all users:
::     pushd E:\Notes\Data\Users
::     for /d %c in (*.*) do @D:\AdminTexts\Scripts\SetPerms %c
::
set ScriptPath=D:\AdminTexts\Scripts
set AdminGroup=Domain admins
set UsersDir=E:\Users
set ServerName=NTServ
set LastName=%1
set NTLogin=%2
set AdminLogin=Administrator

if not "%LastName%"=="" goto argsOk
echo Usage: setperms username [login]
echo Example: setperms Shadursky
echo Example: setperms Shadursky sss
goto done
:argsOk

if not "%NTLogin%"=="" goto validateLogin
for /f %%c in (%UsersDir%\%LastName%\login.nt) do set NTLogin=%%c
if not "%NTLogin%"=="" goto validateLogin
echo Cannot find file LOGIN.NT in directory %UsersDir%\%LastName%, done...
goto done

:validateLogin
if not "%OS%"=="Windows_NT" goto validateLoginOk
REM (%ScriptPath%\getusers | findstr /x /i /c:%NTLogin%) || set NTLogin=
:::  %ScriptPath%\getusers.exe %ServerName% %NTLogin% || (
:::    echo User %LastName% has unknown login: "%NTLogin%"
:::    set NTLogin=%AdminLogin%
:::  )
:validateLoginOk

echo on
xcacls.exe   %UsersDir%\%LastName%    /Y /T    /G "%AdminGroup%:F"  /P SYSTEM:F || goto done
attrib +R +H %UsersDir%\%LastName%\user.id0
attrib +R    %UsersDir%\%LastName%\login.nt
attrib +R    %UsersDir%\%LastName%\*.lnk
xcacls.exe   %UsersDir%\%LastName%       /T /E /P "%AdminGroup%:RXPO;RWXPO"       || goto done
xcacls.exe   %UsersDir%\%LastName%          /E /P  SYSTEM:F;RWX                   || goto done
@if "%NTLogin%"=="" goto UserDone
xcacls.exe   %UsersDir%\%LastName%       /T /E /G  "%NTLogin%:RWXD;RWXD"          || goto done
xcacls.exe   %UsersDir%\%LastName%\login.nt /E /P  "%NTLogin%:R"      /R SYSTEM   || echo gone
xcacls.exe   %UsersDir%\%LastName%\*.id     /E /P  "%NTLogin%:RWXD"   /R SYSTEM   || echo gone
xcacls.exe   %UsersDir%\%LastName%\*.id0    /E /P  "%NTLogin%:R"      /R SYSTEM   || echo gone
xcacls.exe   %UsersDir%\%LastName%\*.lnk    /E /P  "%NTLogin%:RX"     /R SYSTEM   || echo gone
:UserDone
@echo off

:done
